<!--
 * @Author: @liulin
 * @Date: 2022-06-02 09:54:44
 * @LastEditors: @liulin
-->
<template>
  <at-table
    @load="loadData"
    :data="data"
    :page-result="pageResult"
    ref="AtTable"
    :dialogTitle="dialogTitle"
    :dialogVisible="dialogVisible"
    @select-all="handleSelect"
    @select="handleSelect"
    @handleDialogCancel="handleDialogCancel"
    @handleDialogClose="handleDialogClose"
    @handleDialogSubmit="handleDialogSubmit"
    @row-dblclick="handleRowDBClick"
  >
    <!-- <template v-slot:searchInput>
      <el-form
        ref="searchForm"
        :model="searchForm"
        label-width="80px"
        class="search-top"
        @submit.native.prevent
      >
        <project-info-selector
          v-if="isShow"
          v-model="searchForm.projectId"
          style="width: 100%"
          @keyup.enter.native="findinfo"
        ></project-info-selector>
        <el-input
          v-model="searchForm.name"
          placeholder="请输入质量保修名称"
          style="width: 100%"
          clearable
          @keyup.enter.native="findinfo"
        ></el-input>
        <el-date-picker
          v-model="searchForm.finishTime"
          type="date"
          placeholder="请选择竣工验收时间"
          value-format="yyyy-MM-dd"
          format="yyyy-MM-dd"
          clearable
          @keyup.enter.native="findinfo"
        >
        </el-date-picker>
        <el-button
          size="small"
          @click="findinfo"
          type="primary"
          class="el-icon-search search-btn"
        >查询</el-button>
        <el-button
          size="small"
          @click="handleReset"
          type="primary"
          plain
          class="el-icon-refresh"
        >重置</el-button>
      </el-form>
    </template> -->
    <template v-slot:operationBtn>
      <el-button
        size="small"
        type="primary"
        @click="handleAdd"
        icon="el-icon-plus"
      >添加</el-button>
      <ht-delete-button
        :url="deleteUrl"
        :requestMethod="'POST'"
        :htTable="$refs.AtTable"
      >删除</ht-delete-button>
      <import-file
        :importData="importData"
        @load="load"
      ></import-file>
      <el-button
        size="small"
        type="primary"
        @click="handleExport"
        icon="el-icon-download"
        plain
        style="margin-left: 10px"
      >导出</el-button>
    </template>
    <template>
      <el-table-column
        type="selection"
        width="55"
        align="center"
      >
      </el-table-column>
      <el-table-column
        type="index"
        label="序号"
        width="55"
        align="center"
      >
      </el-table-column>
      <el-table-column
        prop="projectInfo.projectName"
        label="项目名称"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>
      <!-- <el-table-column
        prop="name"
        label="质量保修名称"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column> -->
      <el-table-column
        prop="finishTime"
        label="竣工验收时间"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>
      <el-table-column
        prop="warrantyTime"
        label="保修期"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>
      <el-table-column
        prop="remarks"
        label="备注"
        width="100"
        :show-overflow-tooltip="true"
        align="center"
      >
      </el-table-column>
    </template>
    <template v-slot:dialogContent>
      <el-form
        ref="form"
        v-form
        data-vv-scope="form"
        :model="form"
        :rules="rules"
        label-width="130px"
        v-if="dialogVisible"
        v-loading.fullscreen="loading"
      >
        <el-row>
          <el-col :span="12">
            <el-form-item
              label="项目名称"
              prop="projectInfo.projectName"
            >
              <el-input
                v-model="form.projectInfo.projectName"
                placeholder="请选择项目名称"
                @focus="handleFocusProject"
                :disabled="!isShow"
                clearable
              >
                <el-button
                  type="primary"
                  @click="openProject"
                  slot="append"
                  icon="el-icon-search"
                ></el-button>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item
              label="竣工验收时间"
              prop="finishTime"
            >
              <el-date-picker
                v-model="form.finishTime"
                type="date"
                placeholder="选择移交时间"
                value-format="yyyy-MM-dd"
                format="yyyy-MM-dd"
                style="width: 100%"
                clearable
              >
              </el-date-picker>
            </el-form-item>
          </el-col>

          <!-- <el-col :span="12">
            <el-form-item
              label="质量保修名称"
              prop="name"
            >
              <el-input
                v-model="form.name"
                placeholder="请输入质量保修名称"
                clearable
              ></el-input>
            </el-form-item>
          </el-col> -->
        </el-row>
        <el-row>

        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item
              label="保修期"
              prop="warrantyTime"
            >
              <el-input
                v-model="form.warrantyTime"
                placeholder="请输入保修期"
                clearable
                type="textarea"
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item
              label="备注"
              prop="remarks"
            >
              <el-input
                v-model="form.remarks"
                placeholder="请输入备注"
                type="textarea"
                clearable
              ></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <file-table
          @handleFile="handleFile"
          :file="form.accessoryInfo"
          :info='"上传质量保修相关文件"'
        />
        <project-info-dialog
          ref="project"
          :single="true"
          @select="handleSelectProject"
        ></project-info-dialog>
      </el-form>
    </template>
  </at-table>
</template>

<script>
import date from '@/api/date.js'
import req from '@/request.js'
import ProjectInfoDialog from '@/components/dialog/ProjectInfoDialog.vue'
const eipUserSelector = () =>
  import('@/components/selector/EipUserSelector.vue')
export default {
  name: 'Warranty',
  components: {
    ProjectInfoDialog
    // eipUserSelector
  },
  props: {
    pid: {
      type: String,
      default: ''
    },
    isShow: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      importData: {
        title: '质量保修导入',
        templateName: '质量保修.xls',
        downloadUrl: '/../fvue/static/excel/warranty.xlsx',
        importUrl: window.context.cqxy + '/biz/warranty/pm/v1/importExcelData',
        showProject: true,
        projectId: ''
      },
      projectObj: [],
      loading: false,
      searchForm: {
        projectId: '',
        projectCode: '',
        name: '',
        finishTime: ''
      }, //顶部搜索参数
      data: [], //表格数据
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0
      },
      form: {},
      dialogVisible: false,
      dialogTitle: '添加',
      indexArr: [],
      rules: {
        'projectInfo.projectName': {
          required: true,
          message: '请选择项目名称',
          trigger: 'blur'
        }
        // 'projectInfo.projectCode': {
        //   required: true,
        //   message: '请选择项目代码',
        //   trigger: 'blur',
        // },
        // handler: {
        //   required: true,
        //   message: '请输入经办人',
        //   trigger: 'blur',
        // },
        // finalAccountsOpinions: {
        //   required: true,
        //   message: '请输入移交单位',
        //   trigger: 'blur',
        // },
        //  finalAccountsDate: {
        //   required: true,
        //   message: '请选择移交时间',
        //   trigger: 'blur',
        // },
      }
    }
  },
  computed: {
    deleteUrl: function() {
      return window.context.cqxy + '/biz/warranty/pm/v1/delete'
    }
  },
  mounted() {
    this.initProjectAll()
  },
  methods: {
    handleReset() {
      this.searchForm.projectId = ''
      this.searchForm.projectCode = ''
      this.searchForm.name = ''
      this.searchForm.finishTime = ''
      this.$refs['searchForm'].resetFields()
      this.pageResult = {
        page: 1,
        pageSize: 20,
        total: 0
      }
      this.$refs['searchForm'].resetFields()
      this.$nextTick(() => {
        this.$refs.AtTable.load()
      })
    },
    //导入后重新加载数据
    load() {
      this.$refs.AtTable.load()
    },
    //导出
    handleExport() {
      let query = []
      let search = {
        'pm.ID_': this.searchForm.projectId,
        project_code_: this.searchForm.projectCode,
        name_: this.searchForm.name,
        finish_time_: this.searchForm.ffinishTime
      }
      if (!this.isShow) {
        search['pm.ID_'] = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      let data = {
        pageBean: {
          page: 1,
          pageSize: 20,
          showTotal: true
        },
        querys: query
      }
      req
        .downloadPostCopy('${cqxy}/biz/warranty/pm/v1/exportDataToExcel', data)
        .then(res => {
          if (res.status === 200) {
            this.$message.success('导出成功')
          } else {
            this.$message.error('导出失败')
          }
        })
    },
    handleFile(file) {
      this.form.accessoryInfo = file
    },
    handleAdd() {
      this.dialogTitle = '添加'
      this.form = {
        finalAccountsDate: '',
        projectId: '',
        handler: '',
        finishTime: date.getDate(),
        projectInfo: {
          projectName: '',
          projectCode: ''
        },
        accessoryInfo: []
      }
      this.form.projectInfo.projectName = this.projectObj.projectName
      this.form.projectInfo.projectCode = this.projectObj.projectCode
      this.form.projectId = this.projectObj.id
      this.dialogVisible = true
    },
    handleRowDBClick(data) {
      this.dialogTitle = '修改'
      this.form = {...data}
      this.dialogVisible = true
    },
    handleFocusProject() {
      this.$refs.project.open()
    },
    openProject() {
      this.$refs.project.open()
    },
    handleSelectProject(data) {
      this.form.projectId = data.id
      this.form.handler = data.projectManager
      this.form.projectInfo = {...data}
      this.$refs.form.clearValidate()
    },
    handleSelect(selection) {},
    handleDialogCancel() {
      this.dialogVisible = false
      this.form = {
        projectInfo: {},
        accessoryInfo: []
      }
    },
    handleDialogClose() {
      this.form = {
        projectInfo: {},
        accessoryInfo: []
      }
      this.dialogVisible = false
    },
    initProjectAll() {
      //初始单个项目数据
      this.$http
        .post('${cqxy}/biz/projectManagement/pm/v1/detail/' + this.pid)
        .then(
          res => {
            this.projectObj = res.data.value
          },
          error => {
            reject(error)
          }
        )
    },
    //提交保存
    handleDialogSubmit() {
      this.$refs.form.validate(valid => {
        if (valid) {
          if (this.form.accessoryInfo && this.form.accessoryInfo.length > 0) {
            this.form.accessoryInfo.forEach(item => {
              if (item.id) {
                delete item.id
              }
            })
          }
          this.loading = true
          this.$http
            .post('${cqxy}/biz/warranty/pm/v1/save', this.form)
            .then(res => {
              if (res.data.state) {
                this.$refs.form.resetFields()
                this.$message.success(res.data.message)
                this.dialogVisible = false
                this.$refs.AtTable.load()
              } else {
                this.$message.error(res.data.message)
              }
              this.loading = false
            })
        } else {
          this.$message({
            message: '*号必填项,不能为空!',
            type: 'warning'
          })
          return false
        }
      })
    },
    loadData(param, cb) {
      let query = []
      let search = {
        project_id_: this.searchForm.projectId,
        project_code_: this.searchForm.projectCode,
        name_: this.searchForm.name,
        finish_time_: this.searchForm.finishTime
      }
      if (!this.isShow) {
        search['project_id_'] = this.pid
        this.importData.projectId = this.pid
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }

      if (param.querys && param.querys.length) {
        param.querys.push(...query)
      } else {
        param.querys = query
      }
      this.$http
        .post('${cqxy}/biz/warranty/pm/v1/page', param)
        .then(
          resp => {
            let response = resp.data.value
            this.data = response.rows
            this.pageResult = {
              page: response.page,
              pageSize: response.pageSize,
              total: response.total
            }
          },
          error => {
            reject(error)
          }
        )
        .finally(() => {
          if (cb) {
            cb()
          }
        })
    },
    findinfo() {
      this.$refs.AtTable.load()
    }
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/common.scss';
/deep/ .el-range-editor--small .el-range-separator {
  display: contents;
}
</style>

